#include <stdio.h>


/* 
 *     "_",
 *     ATmega128 (. . DD1)
 *     "-1".
 *  1.
 *  06.08.009.
*/


//......................................................................
//       . .
//  ""    "-1".
//......................................................................
void set_begin(void);//      .
unsigned char determ_mode(void);//    .
unsigned char heating(void);    //   .
unsigned char starting(void);   //   .
unsigned char take_off(void);   //   .
unsigned char fly(void);        //   .
unsigned char landing(void);    //   .
unsigned char braking(void);    //   .
void measuring(void);           //     .
void measuring_course(void);    //     .
void measuring_forces(void);    //     .
unsigned char ps_ps_and_cmp_alts(void);//  ,   -
                                   //    .
void piloting(void);            //   .
//      ( 0.2 ) :
unsigned int tau_gas_F(unsigned char gas, int alt_Lst, int alt_Rq);
void course_correction_to_left(void); //    .
void course_correction_to_right(void);//    .
void alt_correction(void);      //      .
void descenting(void);          //  .
enum modes {H,S,T,F,L,B};  //  .
unsigned char present_mode;//   .
enum modes_fly {M,P};      //    .
unsigned char mode_fly;    //     .
unsigned char catch;       //  .(.)  .
unsigned char set_down;    //   ""(1  ) .
unsigned int  time_fst;// ...  . 0.2 ( 10000 ) .
unsigned int  time_slw;//      10  .
unsigned int  time_lbl_fst1;//   ""   .
unsigned int  time_lbl_fst2;//   ""   .
unsigned int alt_set_land;//   . ( [])   .
unsigned char trigger;  //     .
unsigned char trigger_1;//      .
unsigned int  time_lbl_land;//       .
unsigned int alt_req;//       ( []),
                     //    .
unsigned int alt_last[4];//  4     ( []), 
                         // [0] -   ,   -
                         //  ,   -  shturman_int() .
unsigned char d_t;//       
                  // (=tau_d_t, _=0.4 ,
                  //  _=0.2 , _=3.2 ) .
unsigned char tau_d_t;//      .
unsigned char tau_g[4];//    ( 0.2 )
                       //        .
//
//     ()
//----------------------I-------------------------------------------
// 		I    0          1         2          3
//----------------------I-------------------------------------------
// .		I "-"  ""  ""  ""
//----------------------I-------------------------------------------
// tau_g[] (0.2 )	I tau_g[0] ...                   tau_g[3]
//----------------------I-------------------------------------------
//
unsigned int tau_g0_10;// , tau_g0_10=10*tau_g[0],
                       //        .
//        .
unsigned int course_req;//   (    100),
                        //    .
//  10  ( .  100), [0] - 
//  ,    ,   -  shturman_int() :
unsigned int course_last[10];
int delta_fi;//    .
//     (_=0.4 ,
// _=0.2 , _=0.4 , _=4.8 ) :
const unsigned char D_T1[]={2,4,6,8,10,12,14,16,18,20,22,24};
unsigned char tau[12];//     
                      //   ,   0.2 ,
                      // [0] -  D_T1=0.4  .
int d_fi[12];//       
             // ,   ..  100, [0] -  0.4  .
//
//      ()
//----------------------I---------------------------------------------------
// D_T1[] (0.2 )	I    2   4  6  8  10  12  14  16  18  20  22  24
//----------------------I---------------------------------------------------
// tau[] (0.2 )	I tau[0]  ...                                tau[11]
//----------------------I---------------------------------------------------
// d_fi[] (..100)	I d_fi[0] ...                                d_fi[11]
//----------------------I---------------------------------------------------
//
const unsigned char T_1=5;//    .
const unsigned char T_2=7;// ... + .
const unsigned char T_3=9;// .. ++ .
const unsigned char DIFFERENCIAL_1=8;// ...  . .
const unsigned char DIFFERENCIAL_2=2;// ....  . .
const unsigned int D_FI_max=300;// (0.01 ) ..   -
                                // ,  - .  .
// (0.01 )     
// ,  - ,    -   :
const unsigned int D_FI_meas_tau=100;
//............................................................................
//  ""     ("1",+12, -> "1").
//          DD2,   DD2.
//............................................................................
void put_signals(void);//   .
unsigned char signals;//     . :
//  ""	--  0 .
//  ""	--  1 .
//  ""	--  2 .
//  "-"	--  3 .
//  ""	--  4 .
//  ""	--  5 .
//  ""	--  6 .
//  ""	--  7 .
void put_signal_start(void);//   "" .
void read_signal_taho(void);//   "TAHO[0,1,2]" .
unsigned char taho;//    .  :
//  "TAHO[0]" --  0 .
//  "TAHO[1]" --  1 .
//  "TAHO[2]" --  2 .
unsigned char start_1,start_2,shassy;//  "1","2","SHASSY" .
//       :
#include "dcl_hrd"
unsigned char tmp,tmp_1;// tech .


void main(void) {
  //    ( ) :
#include "set_rg1"
  set_begin();//     .
  //   "1", "2" :
  while(1)  {if(start_1==0 && start_2==0){break;} else{;};}
  while(2) {//    .
    present_mode=determ_mode();// .. .
    catch=0;
    switch(present_mode) {//  . :
      case F : {catch=fly();      break;}//  .
      case H : {catch=heating();  break;}//  . 
      case S : {catch=starting(); break;}//  .
      case T : {catch=take_off(); break;}//  .
      case L : {catch=landing();  break;}//  .
      case B : {catch=braking();  break;}//  .
    }
    if(catch==1 || catch==2)break;//     .
  }// END OF while(2)
  //    "-",   :
  signals=0x88;// "1" -> - ;  "1" ->  .
}// END OF main() .

void set_begin(void) {//      .
  present_mode=H;
  mode_fly=M;
  catch=set_down=time_fst=time_slw=time_lbl_fst1=time_lbl_fst2=0;
  alt_set_land=trigger=trigger_1=time_lbl_land=alt_req=0;
  alt_last[0]=alt_last[1]=alt_last[2]=alt_last[3]=0;
  d_t=course_req=delta_fi=tmp=0;  tau_d_t=20;
  tau_g[0]=5;tau_g[1]=10;tau_g[2]=20;tau_g[3]=10;
  tau_g0_10=200;
  course_last[0]=course_last[1]=course_last[2]=course_last[3]=0;
  course_last[4]=course_last[5]=course_last[6]=course_last[7]=0;
  course_last[8]=course_last[9]=0;
  tau[0]=4; tau[1]=6; tau[2]=10; tau[3]=12; tau[4]=16; tau[5]=18;
  tau[6]=22;tau[7]=24;tau[8]=28;tau[9]=30;tau[10]=38;tau[11]=40;
  d_fi[0]=500; d_fi[1]=500; d_fi[2]=800;  d_fi[3]=800;
  d_fi[4]=1000;d_fi[5]=1000;d_fi[6]=1500; d_fi[7]=1500;
  d_fi[8]=2000;d_fi[9]=2000;d_fi[10]=4000;d_fi[11]=6000;
  signals=0x88;// 1 -> "-" ;  1 -> "" .
  put_signals();
}// END OF set_begin() .

//    :
#include "hrd_dpnd"

unsigned char determ_mode(void) {//    .
  unsigned char grnd;//  "SHASSY" .
  grnd = shassy;
  if(time_slw>=T_3 && set_down==0  && grnd==1)return F;//  .
  if(time_slw<=T_1 && grnd==0)                return H;//  .
  if(time_slw>T_1  && time_slw<T_3 && grnd==0)return S;//  .
  if(time_slw>T_1  && time_slw<T_3 && grnd==1)return T;//  .
  if(time_slw>T_3  && set_down==1  && grnd==1)return L;//  .
  if(time_slw>T_3  && grnd==0)                return B;//  .
  if(time_slw<=1   && grnd==1) {                       //     .
    time_slw=T_3+1;mode_fly=P;return F;
  }
  return F;
}

unsigned char heating(void) {//   .
  unsigned int t;//   (0.2 ) .
  //    "-",  ,   :
  signals=0x88;// "1" -> - ;  "1" ->  .
  put_signal_start();//   .
  put_signals();
  t=time_fst; while(time_fst-t<20){;}//  4  .
  read_signal_taho();//   "TAHO[0,1,2]"
  if(taho<1) {//    1( 7) .
    catch=1;
  }
//=======
//   "printf..."  ICC !!!!! .
//=======
  //printf("heating---\n");// tech .
  return catch;
}

unsigned char starting(void) {//   .
  unsigned int t;//   (0.2 ) .
  //  ,   "" :
  signals=0x40;// 1 -> "" .
  put_signals();
  t=time_fst; while(time_fst-t<20){;}//  4  .
  read_signal_taho();//   "TAHO[0,1,2]"
  if(taho<6) {//    6( 7) .
    catch=2;
  }
//=======
//   "printf..."  ICC !!!!! .
//=======
  //printf("starting---\n");// tech .
  return catch;
}

unsigned char take_off(void) {//  .
  unsigned int t;//   (0.2 ) .
  unsigned char i;//   .
  unsigned char check;//     .
  char diff_1[3];//   () .
  char diff_2[2];//    .
  t=0;
  //      "",   "" :
  signals=0x44;// 1 -> "" ;  1 -> "" .
  put_signals();
  t=time_fst; while(time_fst-t<d_t){;}//  d_t (0.2 ) .
  // .   .,   "" :
  signals=0x40;// 1 -> "" .
  put_signals();
  t=time_fst;
  while(time_fst-t<tau_d_t-d_t){;}//  (tau_d_t-d_t) (0.2 ) .
  //      :
  for(i=0;i<3;i++) diff_1[i]=alt_last[i]-alt_last[i+1];
  for(i=0;i<2;i++) diff_2[i]=diff_1[i]-diff_1[i+1];
  //   :
  check=0;
  for(i=0;i<3;i++) if(diff_1[i]>DIFFERENCIAL_1) check=1;
  for(i=0;i<2;i++) if(diff_2[i]>DIFFERENCIAL_2) check=1;
  //         
  //   ,     :
  if(check==0 && d_t<=16)d_t=d_t+2;
  else {d_t=d_t-2;catch=3;}//   .
  //  ,   () :
  switch(tau_d_t) {
    case 20:{tau_d_t=26;break;} case 26:{tau_d_t=20;break;}
  }
//=======
//   "printf..."  ICC !!!!! .
//=======
  //printf("take_off---\n");// tech .
  return catch;
}// END OF take_off() .

unsigned char fly(void) {//  .
  if(mode_fly==M) measuring();
  if(mode_fly==P) piloting();
//=======
//   "printf..."  ICC !!!!! .
//=======
  //printf("fly---\n");// tech .
  return catch;
}

void measuring(void) {//  .
  unsigned int t;//   .
  //   "",     :
  signals=0x20;// 1 -> "";
  put_signals();
  t=time_fst; while(time_fst-t<20){;}//  4  .
  measuring_course();//     .
  measuring_forces();//     .
  mode_fly=P;//     .
}

void measuring_course(void) {//     .
  unsigned int t;//   (0.2 ) .
  unsigned char j;//   .
  int i;//   .
  // i -    (10 -   10 ) .
  // j -      .
  //     ,
  // D_T1[] = 2, 4, 6, 8, 10, ... , 24 (0.2 ) :
  for(j=0;j<12;j++) {
    //    "",    "" :
    signals=0x21;// 1 -> "" ;  1 -> "";
    put_signals();
    t=time_fst; while(time_fst-t<D_T1[j]){;}//  D_T1[j] (0.2 ) .
    //    "",     :
    signals=0x20;// 1 -> "";
    put_signals();
    t=time_fst; while(time_fst-t<50-D_T1[j]){;}//  50-D_T1[j] (0.2 ) .
    //    :
    for(i=8;i>=0;i--) {//  10  -   :
      //      D_FI_meas_tau(0.01 ),
      //    -  :
      if(course_last[i]-course_last[i+1]<D_FI_meas_tau ||
         course_last[i+1]-course_last[i]<D_FI_meas_tau)
      {tau[j]=(9-i)*5;break;}//   .. .
    }
    //        :
    d_fi[j]=course_last[0]-course_last[9];
    if(d_fi[j]<0)d_fi[j]=-d_fi[j];// 
    if(d_fi[j]>4500)break;//    45 .,   .
  }
}// END OF measuring_course() .

void measuring_forces(void) {//     .
  //    -    .
  //   "" :
  signals=0x40;// 1 -> "" .
  tau_g[3]=ps_ps_and_cmp_alts();
  //   "" :
  signals=0x20;// 1 -> "" .
  tau_g[2]=ps_ps_and_cmp_alts();
  //   "" :
  signals=0x10;// 1 -> "" .
  tau_g[1]=ps_ps_and_cmp_alts();
  //   "-" :
  signals=0x8;//  1 -> "-" .
  tau_g[0]=ps_ps_and_cmp_alts();
  tau_g0_10=10*tau_g[0];// ,      .
}// END OF measuring_forces() .

unsigned char ps_ps_and_cmp_alts(void) {//  ,  
                                    //    .
  unsigned int t;//   (0.2 ) .
  put_signals();
  t=time_fst; while(time_fst-t<30){;}//  6  .
  //   ,      :
  if(alt_last[0]>alt_last[1]) {tmp_1=alt_last[0]-alt_last[1];}
  else                        {tmp_1=alt_last[1]-alt_last[0];}
  switch(tmp_1) {// , tmp_1 -    [/] .
    case 0:{tmp=5;break;} case 1:{tmp=4;break;} case 2 :{tmp=3;break;} 
    case 3:{tmp=2;break;} case 4:{tmp=1;break;} default:{tmp=1; break;}
  }
  if(alt_last[0]==alt_last[3])return 15;
  if(alt_last[0]==alt_last[2])return 10;
  return tmp;
}

void piloting(void) {//   .
  //     
  //  10  ,    :
  if(alt_req>alt_last[0]+10){catch=take_off();return;}
  //     
  //  10  ,    :
  if(alt_req+10<alt_last[0])descenting();
  //      ,   ,
  //   10,       :
  if(alt_req!=alt_last[0] && alt_req-alt_last[0]<=10 &&
     alt_last[0]-alt_req<=10){
  alt_correction();//      .
  }
  delta_fi=course_last[0]-course_req;//    .
  //      D_FI_max(0.01 ),
  //     :
  if(delta_fi>D_FI_max){course_correction_to_left();return;}
  //      -D_FI_max(0.01 ),
  //     :
  if((-delta_fi)>D_FI_max){course_correction_to_right();return;}
}// END OF piloting() .

void descenting(void) {// 
  unsigned int t;//   (0.2 ) .
  //    -    .
  //   "-" :
  signals=0x8;//  1 -> "-" .
  put_signals();
  // tau_g0_10 - .( 0.2 )  10 ,   .
  t=time_fst;while(time_fst-t<tau_g0_10){;}//  tau_g0_10(0.2 ) .
}// END OF descenting() .

void alt_correction(void) {//     
  //   -    .
  unsigned int t;//   (0.2 ) .
  unsigned int tau_gas;// (0.2 )     .
  unsigned char gas;//   ,
                    // 1000 - "", 0100 - "",
                    // 0010 - "",   0001 - "-" .
  gas = (signals>>3) & 0xF;//     .
  //   ,     ,
  //     :
  if(alt_last[0]<alt_last[1] && alt_last[0]>alt_req) {;}
  //   ,     ,
  //      :
  if(alt_last[0]<alt_last[1] && alt_last[0]<alt_req) {
    switch (gas) {//       :
      case 1 : gas=2;// "-" -> ""
      case 2 : gas=4;// ""   -> ""
      case 4 : gas=8;// "" -> ""
    }
    signals = gas<<3;
    put_signals();
  }
  //   ,     ,
  //      :
  if(alt_last[0]>alt_last[1] && alt_last[0]>alt_req) {
    switch (gas) {//       :
      case 2 : gas=1;// ""   -> "-"
      case 4 : gas=2;// "" -> ""
      case 8 : gas=4;// "" -> ""
    }
    signals = gas<<3;
    put_signals();
  }
  //   ,     ,
  //     :
  if(alt_last[0]>alt_last[1] && alt_last[0]<alt_req) {;}
  //      (0.2 ) :
  tau_gas=tau_gas_F(gas,alt_last[0],alt_req);
  //   (    ) :
  t=time_fst;while(time_fst-t<tau_gas){;}
}// END OF alt_correction() .

//      (0.2 ) :
unsigned int tau_gas_F(unsigned char gas, int alt_Lst, int alt_Rq) {
  // alt_Lst- , alt_Rq-  .
  unsigned int tmp1;
  int tmp2;
  tmp2=alt_Lst-alt_Rq; if(tmp2<0)tmp2=-tmp2;
  switch (gas) {
    case 1 : tmp1=tau_g[0]*tmp2;// "-"
    case 2 : tmp1=tau_g[1]*tmp2;// ""
    case 4 : tmp1=tau_g[2]*tmp2;// ""
    case 8 : tmp1=tau_g[3]*tmp2;// ""
  }
  return tmp1;
}

void course_correction_to_left(void) {//   
  unsigned int t;//  (0.2 )  .
  unsigned char i;//    .
  // .  .   :
  for(i=0;i<11;i++)if(delta_fi>d_fi[i] && delta_fi<d_fi[i+1])break;
  //    "" :
  signals=signals & 0xFE;// 0 -> "" .
  signals=signals | 0x2;//  1 -> "" .
  put_signals();
  t=time_fst; while(time_fst-t<D_T1[i]){;}//  D_T1[i] 0.2  .
  //      :
  signals=signals & 0xFD;//    0 -> "" .
  put_signals();
  //  (tau[i]-D_T1[i]) 0.2  :
  t=time_fst; while(time_fst-t<(tau[i]-D_T1[i])){;}
}// END OF course_correction_to_left() .

void course_correction_to_right(void) {//   
  unsigned int t;//   .
  unsigned char i;//    .
  delta_fi=-delta_fi;//  
  // .  .   :
  for(i=0;i<11;i++)if(delta_fi>d_fi[i] && delta_fi<d_fi[i+1])break;
  //    "" :
  signals=signals | 0x01;//    1 -> "" .
  signals=signals & 0xFD;//    0 -> "" .
  put_signals();
  t=time_fst; while(time_fst-t<D_T1[i]){;}//  D_T1[i] 0.2  .
  //      :
  signals=signals & 0xFE;// 0 -> "" .
  put_signals();
  //  (tau[i]-D_T1[i]) 0.2  :
  t=time_fst; while(time_fst-t<(tau[i]-D_T1[i])){;}
}// END OF course_correction_to_right() .

unsigned char landing(void) {//  .
  //       01.08.2009 .
  unsigned int t;//   .
  //  -   ,
  //   "-" :
  signals=0x8;//  1 -> "-" .
  //    <= 2 (  ),
  //  ( )   ""    1  :
  if(alt_last[0]-alt_set_land<=2 && trigger==0) {
    signals=0x40;// 1 -> "" .
    put_signals();
    trigger=1;
    t=time_fst; while(time_fst-t<5){;}//  1  .
  }
  put_signals();
  delta_fi=course_last[0]-course_req;//    .
  //      10 ,
  //     :
  if(delta_fi>1000){course_correction_to_left();return 4;}
  //      -10 ,
  //     :
  if(delta_fi<-1000){course_correction_to_right();return 4;}
//=======
//   "printf..."  ICC !!!!! .
//=======
  //printf("landing---\n");// tech .
  return 0;
}// END OF landing() .

unsigned char braking(void) {//  .
  //     :
  if(trigger_1==0){time_lbl_land=time_fst;trigger_1=1;}
  //  -   ,
  //   "-" :
  signals=0x8;//  1 -> "-" .
  //      :
  if(time_fst-time_lbl_land>10) {
    signals=signals | 0x80;//   1 -> "" .
  }
  put_signals();
  delta_fi=course_last[0]-course_req;//    .
  //      10 ,
  //     :
  if(delta_fi>1000){course_correction_to_left();return 5;}
  //      -10 ,
  //     :
  if(delta_fi<-1000){course_correction_to_right();return 5;}
//=======
//   "printf..."  ICC !!!!! .
//=======
  //printf("braking---\n");// tech .
  return 0;
}// END OF braking() .
